﻿using Microsoft.AspNetCore.Mvc;
using System;
using System.Linq;
using UnivateProperties_API.Model.Financial;
using UnivateProperties_API.Model.Timeshare;
using UnivateProperties_API.Repository;
using UnivateProperties_API.Repository.Financial;

namespace UnivateProperties_API.Controllers.Financial
{
    [Route("api/[controller]")]
    [ApiController]
    public class RedirectController : ControllerBase
    {
        private readonly IRepository<Payment> _repo;
        private readonly IPaygateRepository _paygateRepo;
        private readonly IRepository<TimeshareWeek> _timeshareRepo;

        public RedirectController(IRepository<Payment> rp, IPaygateRepository pgr, IRepository<TimeshareWeek> timeshare)
        {
            _repo = rp;
            _paygateRepo = pgr;
            _timeshareRepo = timeshare;
        }

        // POST: api/Redirect
        [HttpPost]
        [Consumes("application/x-www-form-urlencoded")]
        public RedirectResult PostRedirect([FromForm] ReturnToMerchant context)
        {
            string paygateId = "10011072130";
            var payment = _repo.Get(x => x.PayRequestId == context.PAY_REQUEST_ID).FirstOrDefault();
            var timeshareWeek = _timeshareRepo.Get(x => x.Id == Convert.ToInt32(payment.PaymentToken)).FirstOrDefault();
            if (context.TRANSACTION_STATUS == 0)
            {
                string queryResult = _paygateRepo.PaymentQuery(paygateId, payment);
                
                timeshareWeek.StatusId = 32;
                _timeshareRepo.Update(timeshareWeek);
                return Redirect("https://www.pvsl.co.za:97/#/payments/error/" + context.PAY_REQUEST_ID);
            }
            if (context.TRANSACTION_STATUS == 1)
            {
                string queryResult = _paygateRepo.PaymentQuery(paygateId, payment);
                timeshareWeek.StatusId = 1;
                _timeshareRepo.Update(timeshareWeek);
                return Redirect("https://www.pvsl.co.za:97/#/payments/success");
            }
            else if (context.TRANSACTION_STATUS == 2)
            {
                string queryResult = _paygateRepo.PaymentQuery(paygateId, payment);
                timeshareWeek.StatusId = 32;
                _timeshareRepo.Update(timeshareWeek);
                return Redirect("https://www.pvsl.co.za:97/#/payments/error/" + context.PAY_REQUEST_ID);
            }
            else
            {
                string queryResult = _paygateRepo.PaymentQuery(paygateId, payment);
                timeshareWeek.StatusId = 32;
                _timeshareRepo.Update(timeshareWeek);
                return Redirect("https://www.pvsl.co.za:97/#/");
            }

        }
    }
}
