﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using UnivateProperties_API.Model.Properties;

namespace UnivateProperties_API.Model.Campaigns
{
    public class PropertyCampaignItem : BaseEntity
    {
        [ForeignKey("Campaign")]
        public int CampaignId { get; set; }
        [ForeignKey("Property")]
        public int PropertyId { get; set; }
        public string Image { get; set; }

        public virtual Property Property { get; set; }
        public virtual Campaign Campaign { get; set; }

        public virtual ICollection<CampaignItemPlaceHolder> CampaignItemPlaceHolder { get; set; }

        [NotMapped]
        public string Reference
        {
            get
            {
                return Property != null ? Property.PropertyRef : "";
            }
        }
    }
}
