﻿using System.ComponentModel.DataAnnotations.Schema;
using UnivateProperties_API.Model.Properties;
using UnivateProperties_API.Model.Timeshare;
using UnivateProperties_API.Model.Users;

namespace UnivateProperties_API.Model.Financial
{
    public class Payment : BaseEntity
    {
        #region Properties
        [ForeignKey("TimeshareWeek")]
        public int? TimeshareWeekId { get; set; }
        [ForeignKey("Property")]
        public int? PropertyId { get; set; }
        public decimal Amount { get; set; }
        public string PaymentStatus { get; set; }
        public string PaymentToken { get; set; }
        public string Checksum { get; set; }
        public string PayRequestId { get; set; }

        public virtual TimeshareWeek TimeshareWeek { get; set; }
        public virtual Property Property { get; set; }
        public virtual User CreatedBy { get; set; }
        #endregion
    }
}
