﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using UnivateProperties_API.Containers.Timeshare;
using UnivateProperties_API.Model.ProcessFlow;
using UnivateProperties_API.Model.Region;
using UnivateProperties_API.Model.Users;

namespace UnivateProperties_API.Model.Timeshare
{
    public class TimeshareWeek : BaseEntity
    {
        public TimeshareWeek()
        {
        }

        public TimeshareWeek(bool referedByAgent, int? agentId, int? agencyId, int ownerId, bool agentAsRep, bool otherResort, string otherResortName, string resortCode, string resortName, int regionId, string season, string module, string bedrooms, int maxSleep, string unitNumber, string weekNumber, double levyAmount, bool currentYearBanked, string bankedWith, bool leviesPaidInFull, bool weekPlacedForRental, double originalPurchasePrice, DateTime originalPurchaseDate, DateTime arrivalDate, DateTime departureDate, double sellPrice, double askingPrice, double agentCommision, bool mandate, int statusId, Status status, Province region, Individual owner, Agent agent, Agency agency, ICollection<BidItem> bidItems, ICollection<ProcessFlow.ProcessFlow> processFlows, string weekStatus, DateTime datePublished, bool published, string displayOwner, bool customOwner)
        {
            ReferedByAgent = referedByAgent;
            AgentId = agentId;
            AgencyId = agencyId;
            OwnerId = ownerId;
            AgentAsRep = agentAsRep;
            OtherResort = otherResort;
            OtherResortName = otherResortName;
            ResortCode = resortCode;
            ResortName = resortName;
            RegionId = regionId;
            Season = season;
            Module = module;
            Bedrooms = bedrooms;
            MaxSleep = maxSleep;
            UnitNumber = unitNumber;
            WeekNumber = weekNumber;
            LevyAmount = levyAmount;
            CurrentYearBanked = currentYearBanked;
            BankedWith = bankedWith;
            LeviesPaidInFull = leviesPaidInFull;
            WeekPlacedForRental = weekPlacedForRental;
            OriginalPurchasePrice = originalPurchasePrice;
            OriginalPurchaseDate = originalPurchaseDate;
            ArrivalDate = arrivalDate;
            DepartureDate = departureDate;
            SellPrice = sellPrice;
            AskingPrice = askingPrice;
            AgentCommision = agentCommision;
            Mandate = mandate;
            StatusId = statusId;
            Status = status;
            Region = region;
            Owner = owner;
            Agent = agent;
            Agency = agency;
            BidItems = bidItems;
            ProcessFlows = processFlows;
            WeekStatus = weekStatus;
            Publish = published;
            PulbishedDate = datePublished;
            DisplayOwner = displayOwner;
            CustomOwner = customOwner;
        }

        #region Properties
        public bool ReferedByAgent { get; set; }
        [ForeignKey("Agent")]
        public int? AgentId { get; set; }
        [ForeignKey("Agency")]
        public int? AgencyId { get; set; }
        [ForeignKey("Owner")]
        public int OwnerId { get; set; }
        public bool CustomOwner { get; set; }

        public bool AgentAsRep { get; set; }
        public bool OtherResort { get; set; }
        public string OtherResortName { get; set; }
        public string ResortCode { get; set; }
        public string ResortName { get; set; }
        [ForeignKey("Region")]
        public int RegionId { get; set; }
        public string Season { get; set; }
        public string Module { get; set; }
        public string Bedrooms { get; set; }
        public int MaxSleep { get; set; }
        public string UnitNumber { get; set; }
        public string WeekNumber { get; set; }
        public double LevyAmount { get; set; }
        public string DisplayOwner { get; set; }
        public bool CurrentYearBanked { get; set; }
        public string BankedWith { get; set; }

        public bool LeviesPaidInFull { get; set; }
        public bool WeekPlacedForRental { get; set; }
        public double OriginalPurchasePrice { get; set; }
        public DateTime OriginalPurchaseDate { get; set; }
        public DateTime ArrivalDate { get; set; }
        public DateTime DepartureDate { get; set; }
        
        public double SellPrice { get; set; }
        public double AskingPrice { get; set; }
        public double AgentCommision { get; set; }
        public bool Mandate { get; set; }
        public DateTime DateMandated { get; set; }

        [ForeignKey("Status")]
        public int StatusId { get; set; }
        public WeekType WeekType { get; set; }
        public string WeekStatus { get; set; }
        public bool Publish { get; set; }
        public DateTime PulbishedDate { get; set; }
        #endregion

        #region Navigation
        public virtual Status Status { get; set; }
        public virtual Province Region { get; set; }
        public virtual Individual Owner { get; set; }
        public virtual Agent Agent { get; set; }
        public virtual Agency Agency { get; set; }
        public virtual ICollection<BidItem> BidItems { get; set; }
        public virtual ICollection<ProcessFlow.ProcessFlow> ProcessFlows { get; set; } 
        #endregion Navigation
    }
}
